
#coding: latin-1
import misc
import rabbyt
import random
import pygame
from pygame.locals import *



STANDING = 0
WALKING = 1
JUMPING = 2
DEAD = 3
RUNNING = 4
IN_PAIN = 5
BITING = 6
SAWING = 7
SHOOTING = 8
KICKING = 9
QUITE_DEAD = 10

LEFT = 0
RIGHT = 1

GRAVITY = 0.0065

def createLevels():
    story = ["story_1.png", "story_2.png", "story_3.png", "story_4.png", "story5_1.png", "story_6.png"]
    
    backgrounds = ["city01_bg.png", "city01_bg.png", "dopers_bar.png", "dopers_bar.png", "dopers_bar.png"]
    
    screens = [
        ["scr1_1.png", "scr1_2.png", "sidewalk.png", "sidewalk.png", "scr1_3.png"],
        ["scr2_1.png", "sidewalk.png", "scr2_3.png"],
        ["scr3_1.png", "scr3_2.png", "scr3_1.png", "scr3_2.png", "scr3_1.png", "scr3_2.png", "scr3_1.png", "scr3_door.png"],
        ["scr4_1.png", "scr4_2.png", "scr4_3.png"],
        ["scr4_2.png"]]
    
    ents = [[[], [RunnerJunkie((400, -150))], [RunnerJunkie(), RunnerJunkie((200, -150))], [RunnerJunkie(), RunnerJunkie((100, -150))], [Junkie(), Trigger(200)]],
        [[],[Junkie()], [Junkie(), RunnerJunkie((500, -150)), RunnerJunkie((700, -150)), Trigger(100)]],
        [[Junkie((-240, -150))], [RunnerJunkie((400, -150)), RunnerJunkie((410, -150)), RunnerJunkie((420, -150)), RunnerJunkie((800, -150))], [RunnerJunkie((400, -150)), RunnerJunkie((500, -150)), RunnerJunkie((700, -150)), RunnerJunkie((900, -150)), ChainsawJunkie((800, -150))], [ChainsawJunkie((200, 300)), RunnerJunkie((430, -150)), RunnerJunkie((400, -150))], [Gunman(), Junkie((100, -150))], [Gunman((280, -150)), Gunman((270, -150))], [Junkie((50, -150))], [RunnerJunkie(), Trigger()]],
        [[],[Gunman((140, -150)), Gunman((200, -150)), Gunman((220, -150)), Gunman((300, -150)), Gunman((330, -150)), Gunman((380, -150))], [Trigger(-500)]],
        [[Fuhrer(), Trigger(-500)]]]
    #ents[0][0][0].pos.x = 200
    #ents[0][2][0].pos.x = 300
    for i in range(30):
        ents[3][0].append( RunnerJunkie( (400 + i*200, -150) ) )
    for i in range(15):
            ents[3][2].append( ChainsawJunkie( (300 + i*250, -150) ) )
    
    return (story, ents, screens, backgrounds)
    

GAME = 0
STORY = 1
CONGRATS = 2

class Game():
    def init(self):
        self.player = Player()
        self.player.pos.x = -300
        self.entH = EntityHandler()
        self.level = 1
        self.screen = 0
        self.partH = ParticleHandler()
        self.story, self.entH.ents, self.screenImages, self.bgImages = createLevels()
        self.state = STORY
        self.storyCntr = 0
        pygame.mixer.music.load("./data/Cool Rock.mp3")
        pygame.mixer.music.play(-1)
        
        for level in self.screenImages:
            for i in level:
                misc.gSpriteHandler.Get("./data/" + i)
                
    def NextLevel(self):
        self.level+=1
        self.screen = 0
        self.player.pos.x = -390
        game.partH.Clear()
        game.state = STORY # visa en seriesnutt fre varje bana
        self.storyCntr=0
        if self.level==3:
            pygame.mixer.music.load("./data/Chipper.mp3")
            pygame.mixer.music.play(-1)
            
    def EnemyAlive(self):
        for e in self.entH.getActive(self.level, self.screen):
            if not hasattr(e, "ignoreMe"):
                if e.state!=DEAD and e.pos.x >-400 and e.isEnemy:
                    return True
        return False
        
        
    
    def Update(self, ms):
        if self.state==GAME:
            if self.player.state == DEAD:
                if misc.keys[K_RETURN]:                
                    self.player.__init__()
                    self.screen = 0
                    self.story, self.entH.ents, self.screenImages, self.bgImages = createLevels()
                    self.partH.Clear()
            
            self.player.Update(ms)
            if self.player.pos.x>400:
                if self.EnemyAlive():
                    self.player.pos.x = 400
                elif self.screen+1 > len(self.entH.ents[self.level-1])-1:
                    if self.level < len(self.entH.ents):
                        self.NextLevel()
                else:
                    self.screen+=1
                    self.player.pos.x = -390
                    game.partH.Clear()
            elif self.player.pos.x<-400:
                if self.screen>0:
                    self.screen-=1
                    self.player.pos.x = 380
                    game.partH.Clear()
                else:
                    self.player.pos.x = -400
            for e in self.entH.getActive(self.level, self.screen):
                e.Update(ms)
            self.partH.Update(ms)
        elif self.state==STORY:
            if self.level<6:
                if misc.keys[K_RETURN]:
                    misc.keys[K_RETURN] = False
                    if self.level==5 and self.storyCntr==0:
                        self.storyCntr+=1
                    else:
                        self.state = GAME
    
    def Render(self):
        if self.state==GAME:
            misc.gSpriteHandler.Get("./data/" + self.bgImages[self.level-1]).render()
            try:
                misc.gSpriteHandler.Get("./data/" + self.screenImages[self.level-1][self.screen]).render()
            except:
                print "level=", self.level, " screen=", self.screen
                print self.screenImages[self.level-1]
            self.player.Render()
            for e in self.entH.getActive(self.level, self.screen):
                e.Render()
            self.partH.Render()
            
            #UI, typ ;D
            if self.player.health > 0:
                healthbar = rabbyt.Sprite()
                healthbar.green, healthbar.blue = 0, 0
                healthbar.shape = (0, 10, self.player.health, 0)
                healthbar.top = 290
                healthbar.left = -390
                healthbar.render()
            else:
                misc.gSpriteHandler.Get("./data/gameover.png").render()
        elif self.state == STORY:
            if self.level==5:
                misc.gSpriteHandler.Get("./data/story5_" + str(self.storyCntr+1) + ".png").render()
            else:
                misc.gSpriteHandler.Get("./data/" + self.story[self.level-1]).render()
            if self.level < 6:
                hitenter = misc.gSpriteHandler.Get("./data/hitenter.png")
                hitenter.y = -280
                hitenter.render()
            
            

BLOODSPLAT = 0
SHOTTRAIL = 1
SMOKE = 2
class ParticleHandler():
    def __init__(self):
        self.parts = []
        
    def Clear(self):
        del self.parts[:]
    
    def Add(self, type, x, y, ttl = 2000, xspeed = None, yspeed = None):
        if xspeed==None:
            xspeed = (random.randint(0, 100)-50)*0.01
            yspeed = (random.randint(0, 100)-50)*0.01
        self.parts.append( [type, x, y, ttl, xspeed, yspeed] )
    def Render(self):
        for p in self.parts:
            if p[0]==BLOODSPLAT:
                sprite = misc.gSpriteHandler.Get("./data/bloodsplat.png")
                sprite.x = p[1]
                sprite.y = p[2]
                sprite.scale = 0.3
                sprite.render()
            elif p[0]==SHOTTRAIL:
                sprite = misc.gSpriteHandler.Get("./data/shottrail.png")
                sprite.x = p[1]
                sprite.y = p[2]
                sprite.alpha = 0.3
                sprite.render()
            elif p[0]==SMOKE:
                sprite = misc.gSpriteHandler.Get("./data/smoke.png")
                sprite.x = p[1]
                sprite.y = p[2]
                sprite.scale = ((1000.0-p[3])/1000.0)*4
                if p[3] < 299:
                    sprite.alpha = p[3]/300.0
                    print "alpha: ", sprite.alpha
                else:
                    sprite.alpha = 1
                sprite.render()

                
                
    
    def Update(self, ms):
        toRemove = []
        for p in self.parts:
            if p[3] > 0:
                p[3] -= ms
            else:
                toRemove.append(p)
            p[1]+=p[4]*ms
            p[2]+=p[5]*ms
            if p[0]==BLOODSPLAT:
                p[5]-=GRAVITY*0.2*ms
                if p[2]<-150:
                    p[2] = -150
                    p[4], p[5] = 0, 0
            elif p[0]==SMOKE:
                p[2]+=0.01*ms
            
                
        for p in toRemove:
            self.parts.remove(p)


class EntityHandler():
    def __init__(self):
        self.ents = None
    
    def getActive(self, level, screen):
        return self.ents[level-1][screen]

class Entity():
    def __init__(self):
        self.pos = misc.vec2()
    def Update(self, ms):
        pass
    def Render(self):
        pass
    def OnCollide(self):
        pass

class VisibleEntity(Entity):
    def __init__(self):
        Entity.__init__(self)
        self.sprite = rabbyt.Sprite()
        
    def Width(self):
        return self.sprite.right - self.sprite.left
    
    def Height(self):
        return self.sprite.top - self.sprite.bottom
    
    
#har spelet att hoppa till nsta bana nr spelaren passerat den och alla fiender p skrmen r dda..
class Trigger(Entity):
    def __init__(self, pos = 0):
        Entity.__init__(self)
        self.pos = pos
        self.ignoreMe = True
        
    def Update(self, ms):
        if game.player.pos.x > self.pos and game.EnemyAlive()==False:
            game.NextLevel()
            
        
        

PLAYER_WALKSPEED = 0.35
class Player(VisibleEntity):
    def __init__(self):
        VisibleEntity.__init__(self)
        self.sprite = rabbyt.Sprite()
        self.walkAnim = 1
        self.walkAnimTmr = 0
        self.state = WALKING
        self.dir = RIGHT
        self.pos.y = -150.0
        self.yspeed = 0.0
        self.xspeed = 0.0
        self.shootTimer = 0
        self.shootAnimTmr = 0
        self.health = 100
    
    def IsOnGround(self):
        return self.pos.y <= -150.0
    
    def Hurt(self, amount):
        self.health-=amount
    
    #kollar vad man trffade d man skjuter. returnerar (obj, hitpos). trffade man inget s returnas None
    def WhatWasHit(self):
        shoty = self.pos.y + self.Height()*0.4
        
        ents = game.entH.getActive(game.level, game.screen)
        
        couldBeHit = []
        
        for e in ents:
            if hasattr(e, "ignoreMe"):
                pass            
            elif e.pos.x + 0.5*e.Width() > self.pos.x + 0.5*self.Width() and e.pos.y + e.Height() > shoty and e.pos.y < shoty:
                couldBeHit.append(e)
        
        nearest = None
        for e in couldBeHit:
            if nearest==None:
                nearest = e
            else:
                if e.pos.x < nearest.pos.x:
                    nearest = e
        
        shotx = self.pos.x + self.Width()*0.5
        
        if nearest==None:
            while shotx<=400:
                game.partH.Add(SHOTTRAIL, shotx, shoty, 50, 0, 0)
                shotx+=20
            return None
        else:
            colx = nearest.pos.x - nearest.Width()*0.4
            while shotx<=colx:
                game.partH.Add(SHOTTRAIL, shotx, shoty, 50, 0, 0)
                shotx+=20

            return (nearest, misc.vec2(nearest.pos.x - nearest.Width()*0.4, shoty))


    def Render(self):
        if self.state==DEAD:
            self.sprite = misc.gSpriteHandler.Get("./data/dead.png")
        else:
            if self.state==WALKING:
                fname = "./data/walk" + str(self.walkAnim) + ".png"
            elif self.state==STANDING or self.state==JUMPING:
                fname = "./data/stand.png"
            self.sprite = misc.gSpriteHandler.Get(fname)
            self.sprite.scale = 0.5
        
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y #+ (self.sprite.top - self.sprite.bottom)*0.5
        
        self.sprite.render()
        
        if self.state!=DEAD:
            #rita ut armarna och vapnet
            if self.shootAnimTmr<100:
                fname = "./data/arms_shotg_shoot.png"
            else:
                fname = "./data/arms_shotg.png"
            arms = misc.gSpriteHandler.Get(fname)
            arms.x = self.sprite.x
            arms.y = self.pos.y + (self.sprite.top - self.sprite.bottom)*0.5
            arms.scale = 0.5
            arms.render()
        
        
        
    def Update(self, ms):
        if self.state==DEAD:
            if self.pos.y>-150:
                self.pos.x-=ms
                self.pos.y-=0.5*ms
        elif self.health <= 0:
            self.state = DEAD
            self.pos.y+=80
            for i in range(155):
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
        else:


            if self.shootAnimTmr < 100:
                self.shootAnimTmr+=ms
            if self.shootTimer > 0:
                self.shootTimer-=ms
            elif misc.keys[K_SPACE]:
                self.shootAnimTmr = 0
                self.shootTimer = 350
                misc.gSoundHandler.Get("./data/shotg.wav").play()
                #game.partH.Add(SMOKE, self.pos.x+self.Width()*0.5, self.pos.y+self.Height()*0.4, 2000, 0, 0)
                wwh = self.WhatWasHit()
                if wwh != None:
                    if hasattr(wwh[0], "Hurt"):
                        wwh[0].Hurt(30)
                        for i in range(10):
                            game.partH.Add(BLOODSPLAT, wwh[1].x, wwh[1].y, 5000)
            
            if self.IsOnGround():
                if misc.keys[K_LEFT]:
                    self.pos.x-=ms*PLAYER_WALKSPEED
                    self.state = WALKING
                    self.dir = LEFT
                elif misc.keys[K_RIGHT]:
                    self.pos.x+=ms*PLAYER_WALKSPEED
                    self.state = WALKING
                    self.dir = RIGHT
                else:
                    self.state = STANDING
                    
                if misc.keys[K_UP]:
                    misc.keys[K_UP] = False
                    self.yspeed = 1.5
                    if self.state==WALKING:
                        if self.dir==RIGHT:
                            self.xspeed = PLAYER_WALKSPEED
                        else:
                            self.xspeed = -PLAYER_WALKSPEED
                    else:
                        self.xspeed = 0
                    self.state = JUMPING
                
            else:
                self.state = JUMPING

                
            if self.state==WALKING:
                self.walkAnimTmr+=ms
                if self.walkAnimTmr>70:
                    self.walkAnimTmr = 0
                    if self.dir==RIGHT:
                        self.walkAnim+=1
                    else: 
                        self.walkAnim-=1
                    if self.walkAnim > 5:
                        self.walkAnim = 1
                    elif self.walkAnim < 1:
                        self.walkAnim = 5
            elif self.state == JUMPING:
                self.yspeed -= ms * GRAVITY
                self.pos.y+=self.yspeed*ms
                self.pos.x+=self.xspeed*ms
                if self.pos.y<-150.0:
                    self.pos.y = -150.0
        
        

class Junkie(VisibleEntity):
    def __init__(self, pos = (0,-150)):
        VisibleEntity.__init__(self)
        self.pos.y = pos[1]
        self.pos.x = pos[0]
        self.animTmr = 0
        self.FrameNr = 1
        self.state = STANDING
        self.health = 10
        self.sprite = misc.gSpriteHandler.Get("./data/junkie1_dead.png")
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.isEnemy = False
        
    def Hurt(self, amount):
        self.health-=amount
        
    def Render(self):
        if self.state==STANDING:
            fname = "./data/junkie1_stand" + str(self.FrameNr) + ".png"
        elif self.state==DEAD:
            fname = "./data/junkie1_dead.png"
        self.sprite = misc.gSpriteHandler.Get(fname)
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.sprite.render()
        
    def Update(self, ms):
        self.animTmr+=ms
        if self.state==STANDING:
            if self.animTmr>700:
                self.animTmr=0
                self.FrameNr+=1
            if self.FrameNr>2:
                self.FrameNr=1
        if self.health <= 0:
            self.state = DEAD
            
class RunnerJunkie(Junkie):
    def __init__(self, pos = (0,-150)):
        Junkie.__init__(self, pos)
        self.state = RUNNING
        self.sprite = misc.gSpriteHandler.Get("./data/junkie1_dead.png")
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.painTimer = 0
        self.bleedTimer = 0
        self.biteTimer = 0
        self.health = 60
        self.isEnemy = True
        
    def Hurt(self, amount):
        Junkie.Hurt(self, amount)
        self.painTimer = 200
        
        
    def Render(self):
        if self.state==RUNNING:
            fname = "./data/junkie2_running" + str(self.FrameNr) + ".png"
        elif self.state==DEAD:
            fname = "./data/junkie2_dead.png"
        elif self.state==IN_PAIN:
            fname = "./data/junkie2_hurt.png"
        elif self.state==BITING:
            fname = "./data/junkie2_biting" + str(self.FrameNr) + ".png"
        self.sprite = misc.gSpriteHandler.Get(fname)
        self.sprite.scale = 0.9
        self.sprite.x = self.pos.x
        """if self.state==DEAD:
            self.sprite.y = self.pos.y
        else:"""
        self.sprite.bottom = self.pos.y
        self.sprite.render()
        
    def Update(self, ms):
        self.animTmr+=ms
        if self.pos.y>-150:
            self.pos.y-=0.5*ms
        
        if self.state==DEAD:
            if self.pos.y>-150:
                self.pos.x+=ms
        elif self.health <= 0:
            self.state = DEAD
            self.pos.y+=80
            for i in range(55):
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
            
            
         
        elif self.painTimer>0:
            self.painTimer-=ms
            self.pos.x+= 0.3*ms
            self.state = IN_PAIN
            self.bleedTimer+=ms
            while self.bleedTimer>2:
                self.bleedTimer-=2
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
        else: # varken dd eller paralyserad av smrta..
            if self.state==RUNNING:
                if self.animTmr>80:
                    self.animTmr=0
                    self.FrameNr+=1
                    self.pos.x -= ms*1.7
                if self.FrameNr>4:
                    self.FrameNr=1
                if game.player.pos.x + game.player.Width()*0.5 > self.pos.x - self.Width()*0.6:
                    if self.pos.x > game.player.pos.x:
                        self.state = BITING
                        self.FrameNr = 1

            elif self.state==BITING:
                if game.player.state == DEAD:
                    self.state = RUNNING
                if game.player.pos.x + game.player.Width()*0.5 < self.pos.x - self.Width()*0.5:
                    self.state = RUNNING
                elif game.player.pos.x > self.pos.x:
                    self.state = RUNNING

                if self.biteTimer<20:
                    self.biteTimer+=ms
                else:
                    self.biteTimer = 0
                    game.player.Hurt(0.7)
                    game.partH.Add(BLOODSPLAT, self.pos.x-self.Width()*0.45, self.pos.y + self.Height()*0.75)
                    
                if self.animTmr>100:
                    self.FrameNr+=1
                    self.animTmr=0
                if self.FrameNr>2:
                    self.FrameNr=1
                if ((self.pos.x - game.player.pos.x) + (self.pos.y - game.player.pos.y))**2 < 4000:
                    self.pos.x = game.player.pos.x+20
                    self.pos.y = game.player.pos.y
                else:
                    self.state = RUNNING
            elif self.state==IN_PAIN:
                if self.painTimer <= 0:
                    self.state = RUNNING
                    
class ChainsawJunkie(Junkie):
    def __init__(self, pos = (0,-150)):
        Junkie.__init__(self, pos)
        self.state = STANDING
        self.sprite = misc.gSpriteHandler.Get("./data/junkie1_dead.png")
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.painTimer = 0
        self.bleedTimer = 0
        self.biteTimer = 0
        self.health = 450
        self.isEnemy = True
        
    def Hurt(self, amount):
        Junkie.Hurt(self, amount)
        self.painTimer = 10
        
        
    def Render(self):
        if self.state==WALKING:
            fname = "./data/chainsawer_walk" + str(self.FrameNr) + ".png"
        elif self.state==DEAD:
            fname = "./data/junkie1_dead.png"
        elif self.state==IN_PAIN:
            fname = "./data/chainsawer_pain.png"
        elif self.state==STANDING:
            fname = "./data/chainsawer_walk1.png"
        elif self.state==SAWING:
            fname = "./data/chainsawer_attack.png"
        self.sprite = misc.gSpriteHandler.Get(fname)
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.sprite.render()
        
    def Update(self, ms):
        self.animTmr+=ms
        if self.pos.y>-150:
            self.pos.y-=0.5*ms
        
        if self.state==DEAD:
            if self.pos.y>-150:
                self.pos.x+=ms
        elif self.health <= 0:
            self.state = DEAD
            self.pos.y+=80
            for i in range(55):
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)

            
         
        elif self.painTimer>0:
            self.painTimer-=ms
            self.pos.x+= 0.5*ms
            self.state = IN_PAIN
            self.bleedTimer+=ms
            while self.bleedTimer>2:
                self.bleedTimer-=2
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
        else: # varken dd eller paralyserad av smrta..
            if self.state==WALKING:
                if self.animTmr>60:
                    self.animTmr=0
                    self.FrameNr+=1
                    self.pos.x -= ms*0.6
                if self.FrameNr>4:
                    self.FrameNr=1
                if game.player.pos.x + game.player.Width()*0.5 > self.pos.x - self.Width()*0.6:
                    if self.pos.x > game.player.pos.x:
                        self.state = SAWING
            elif self.state==SAWING:
                if game.player.state == DEAD:
                    self.state = WALKING
                if game.player.pos.x + game.player.Width()*0.5 < self.pos.x - self.Width()*0.5:
                    self.state = WALKING
                elif game.player.pos.x > self.pos.x:
                    self.state = WALKING
                if self.biteTimer<20:
                    self.biteTimer+=ms
                else:
                    self.biteTimer = 0
                    if game.player.pos.x + game.player.Width()*0.5 > self.pos.x - self.Width()*0.5 and game.player.pos.x - game.player.Width()*0.5 < self.pos.x and game.player.pos.y < self.pos.y + self.Height()*0.75:
                        game.player.Hurt(4)
                        if game.player.pos.x > self.pos.x - self.Width()*0.5:
                            game.player.pos.x = self.pos.x - self.Width()*0.5
                        game.player.pos.x -= 5
                        for i in range(25):
                            game.partH.Add(BLOODSPLAT, self.pos.x-self.Width()*0.45, self.pos.y + self.Height()*0.55)
        
                if self.animTmr>100:
                    self.FrameNr+=1
                    self.animTmr=0
                if self.FrameNr>2:
                    self.FrameNr=1
            elif self.state == STANDING:
                #if game.player.pos.x < self.pos.x:
                self.state = WALKING
            elif self.state == IN_PAIN:
                if self.painTimer<=0:
                    self.state = STANDING


class Gunman(Junkie):
    def __init__(self, pos = (0,-150)):
        Junkie.__init__(self, pos)
        self.state = STANDING
        self.sprite = misc.gSpriteHandler.Get("./data/junkie1_dead.png")
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.painTimer = 0
        self.bleedTimer = 0
        self.shootTimer = random.randint(0, 500)
        self.health = 100
        self.isEnemy = True
        
    def Hurt(self, amount):
        Junkie.Hurt(self, amount)
        self.painTimer = 200
        
    def Shoot(self):
        shotx = self.pos.x
        shoty = self.pos.y + self.Height()*0.6

        
        ydir = (random.random() - 0.5) * 30
        
        misc.gSoundHandler.Get("./data/handgun.wav").play()
        
        while shotx > -450 and shoty > -150:
            game.partH.Add(SHOTTRAIL, shotx, shoty, 50, 0, 0)
            shotx-=20
            shoty+=ydir
            if shotx < game.player.pos.x + game.player.Width()*0.5 and shotx > game.player.pos.x - game.player.Width()*0.5 and shoty > game.player.pos.y and shoty < game.player.pos.y + game.player.Height():
                game.player.Hurt(5 + random.randint(0, 10))
                for i in range(20):
                    game.partH.Add(BLOODSPLAT, shotx, shoty)
                break
                        
        
        
    def Render(self):
        if self.state==DEAD:
            fname = "./data/gunman_dead.png"
        elif self.state==IN_PAIN:
            fname = "./data/gunman_pain.png"
        elif self.state==STANDING:
            fname = "./data/gunman_stand.png"
        elif self.state==SHOOTING:
            fname = "./data/gunman_shoot.png"
        self.sprite = misc.gSpriteHandler.Get(fname)
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.sprite.render()
        
    def Update(self, ms):
        self.animTmr+=ms
        if self.pos.y>-150:
            self.pos.y-=0.5*ms
        
        if self.state==DEAD:
            if self.pos.y>-150:
                self.pos.x+=ms
        elif self.health <= 0:
            self.state = DEAD
            self.pos.y+=80
            for i in range(55):
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
            
         
        elif self.painTimer>0:
            self.painTimer-=ms
            self.pos.x+= 0.25*ms
            self.state = IN_PAIN
            self.bleedTimer+=ms
            while self.bleedTimer>3:
                self.bleedTimer-=3
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
        else: # varken dd eller paralyserad av smrta..
            if self.state==SHOOTING: # har just skjutit, visar rekylanim..
                if game.player.state == DEAD:
                    self.state = STANDING
                if self.animTmr>100:
                    self.FrameNr=0
                    self.animTmr=0
                    self.state = STANDING
            elif self.state == STANDING:
                if game.player.pos.x < self.pos.x:
                    if self.shootTimer > 600:
                        self.Shoot()
                        self.shootTimer = 0
                        self.state = SHOOTING
                        self.animTmr = 0
                    else:
                        self.shootTimer+=ms
            elif self.state == IN_PAIN:
                if self.painTimer<=0:
                    self.state = STANDING


class Fuhrer(Junkie):
    def __init__(self, pos = (0,-150)):
        Junkie.__init__(self, pos)
        self.state = STANDING
        self.sprite = misc.gSpriteHandler.Get("./data/junkie1_dead.png")
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.painTimer = 0
        self.bleedTimer = 0
        self.shootTimer = random.randint(0, 500)
        self.health = 800
        self.isEnemy = True
        self.dir = LEFT
        self.postDeadDelay = 8000
        
    def Hurt(self, amount):
        Junkie.Hurt(self, amount)
        self.painTimer = 100
        
    def Shoot(self):
        shotx = self.pos.x - self.Width()*0.6
        shoty = self.pos.y + self.Height()*0.3

        
        ydir = (random.random() - 0.5) * 30
        
        misc.gSoundHandler.Get("./data/handgun.wav").play()
        
        while shotx > -450 and shoty > -150:
            game.partH.Add(SHOTTRAIL, shotx, shoty, 50, 0, 0)
            shotx-=20
            shoty+=ydir
            if shotx < game.player.pos.x + game.player.Width()*0.5 and shotx > game.player.pos.x - game.player.Width()*0.5 and shoty > game.player.pos.y and shoty < game.player.pos.y + game.player.Height():
                game.player.Hurt(3 + random.randint(0, 5))
                game.player.pos.x -= 2
                for i in range(35):
                    game.partH.Add(BLOODSPLAT, shotx, shoty)
                break
                        
        
        
    def Render(self):
        if self.state==QUITE_DEAD or self.state==DEAD:
            fname = "./data/fhrer_dead.png"
        elif self.state==IN_PAIN:
            fname = "./data/fhrer_hurt.png"
        elif self.state==STANDING:
            fname = "./data/fhrer_stand.png"
        elif self.state==SHOOTING:
            fname = "./data/fhrer_shoot.png"
        elif self.state==WALKING:
            self.FrameNr = self.FrameNr % 3
            if self.FrameNr == 0:
                fname = "./data/fhrer_stand.png"
            else:
                fname = "./data/fhrer_walk" + str(self.FrameNr) +".png"
        elif self.state==KICKING:
            fname = "./data/fhrer_kick.png"
            
        self.sprite = misc.gSpriteHandler.Get(fname)
        self.sprite.x = self.pos.x
        self.sprite.bottom = self.pos.y
        self.sprite.render()
        
    def Update(self, ms):
        if self.pos.x > 400:
            self.pos.x = 400
        self.animTmr+=ms
        if self.pos.y>-150:
            self.pos.y-=0.5*ms
        
        if self.state==QUITE_DEAD:
            self.postDeadDelay-=ms
            if self.postDeadDelay<0:
                self.state=DEAD
            if self.pos.y>-150:
                self.pos.x+=ms
        elif self.health <= 0:
            self.state = QUITE_DEAD
            self.pos.y+=120
            for i in range(85):
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
        elif self.painTimer>0:
            self.painTimer-=ms
            if self.pos.x + self.Width()*0.4 < 400:
                self.pos.x+= 0.25*ms
            self.state = IN_PAIN
            self.bleedTimer+=ms
            while self.bleedTimer>1:
                self.bleedTimer-=1
                game.partH.Add(BLOODSPLAT, self.pos.x, self.sprite.y)
        else: # varken dd eller paralyserad av smrta..
        
            
            if game.player.pos.x + game.player.Width()*0.5 > self.pos.x - self.Width()*0.25:
                self.state = KICKING
                self.animTmr = 0
            if game.player.pos.x + game.player.Width()*0.5 > self.pos.x - self.Width()*0.15:    
                game.player.pos.x = self.pos.x - self.Width()*0.15 - game.player.Width()*0.5
                

        
            if self.state==SHOOTING: # har just skjutit, visar rekylanim..
                if self.animTmr>15:
                    self.animTmr=0
                    self.state = WALKING
            elif self.state == STANDING:
                if game.player.pos.x < self.pos.x:
                    dist = (self.pos.x - self.Width()*0.5) - (game.player.pos.x+game.player.Width()*0.5)
                    if dist <-90:
                        self.state = KICKING
                        self.animTmr = 0
                    
                    if dist > 200 or dist < 100:
                        self.state = WALKING
                    
                    if game.player.state != DEAD and self.shootTimer > 50:
                        self.Shoot()
                        self.shootTimer = 0
                        self.state = SHOOTING
                        self.animTmr = 0
                    else:
                        self.shootTimer+=ms
            elif self.state == IN_PAIN:
                if self.painTimer<=0:
                    self.state = STANDING
            elif self.state == WALKING:
                dist = (self.pos.x - self.Width()*0.5) - (game.player.pos.x+game.player.Width()*0.5)
                if dist < 100:
                    self.dir = RIGHT
                    if dist <-50:
                        self.state = KICKING
                        self.animTmr = 0
                else:
                    if dist < 200:
                        self.state = STANDING
                    else:
                        self.dir = LEFT

                if self.dir == LEFT:
                    self.pos.x -= ms*0.2
                else:
                    self.pos.x += ms*0.1

                if self.animTmr > 90:
                    self.FrameNr+=1
                    self.animTmr = 0
                
                if self.animTmr > 90:
                    self.animTmr = 0
                    
                    if self.dir==LEFT:
                        self.FrameNr-=1
                        if self.FrameNr<0:
                            self.FrameNr = 3
                    else:
                        self.FrameNr+=1
                        if self.FrameNr>3:
                            self.FrameNr = 0
                                
                
                if game.player.state != DEAD and self.shootTimer > 50:
                    self.Shoot()
                    self.shootTimer = 0
                    #self.state = SHOOTING
                    #self.animTmr = 0
                else:
                    self.shootTimer+=ms
            elif self.state == KICKING:
                if self.animTmr < 150:
                    game.player.pos.x-=ms
                if self.animTmr > 300:
                    self.state = STANDING
                    
                    

            
                    
        
            
        

                
        
game = Game()